#ifndef _frequent_strings_h_
#define _frequent_strings_h_

#include "CSAfor2DB.h"
#include "CHgtArray.h"
#include "RMQ_succinct.h"
#include "WaveletTree.h"
#include <stdlib.h>
#include <iostream>
#include <stdio.h>
#include <stack>
#include <vector>
using namespace std;

/** 
 * Calculates frequent substrings
 */
class FrequentStrings
{
public:
  // returns all strings that occurr >= min times in db1 and <= max times in db2
  void frequent(char*, char*, int, char, double, double);

  // print string t[SA[p]..SA[p] + l - 1]
  void print(CSA*, ulong, ulong);

private:
    void PushNewNode(ulong, ulong, ulong, ulong, ulong);
    void TestDataStructures();

    class DeltaArray
    {
    private:
        ulong *A;
        ulong startPos;
    ulong size; 
    public:
        DeltaArray(ulong);
        ~DeltaArray();
        void Add(ulong);
        void Remove(ulong);
        ulong Sum(ulong);
        ulong Top();
    };

    class StringDepth
    {
    private:
        BVTree *R;
        ulong topIndex, prevIndex, nodeCount;
    public:
        StringDepth(ulong);
        ~StringDepth();
        void PrintVector();
        ulong FindDepth(ulong);
        void Push(ulong);
        ulong Top();
        ulong Parent();
        void Pop();
    };

    class CorrectionFactor
    {
    private:
        BVTree *C;
        ulong topIndex, prevIndex, nodeCount;
    public:
        CorrectionFactor();
        ~CorrectionFactor();
        void PrintVector();
        ulong Top();
        void SumTopNodes();
        void Pop();
        void Push(ulong);
        void AddByOne(ulong);
    };


    DeltaArray *S1, *S2;  // number of leaves in subtree
    CorrectionFactor *C1, *C2;      // correction factors
    StringDepth *R;       // String depths
};

#endif
